local jetfile = "client/CosmicMetal/JetColor.txt"
local flashfile = "client/CosmicMetal/FlashColor.txt"

COM_AddCommand("cms_jetcolor", function(player, col)
	if player
		if col and R_GetColorByName(col)
			local f = io.openlocal(jetfile, "w+")
			f:write(col)
			f:close()
			rawset(_G, "jetcolor", R_GetColorByName(col))
			CONS_Printf(player, "Jet Color set to "..R_GetNameByColor(R_GetColorByName(col)))
		else
			CONS_Printf(player, "cms_jetcolor <color> | Sets the color of Cosmetal's jets.")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end, COM_LOCAL)

COM_AddCommand("cms_flashcolor", function(player, col)
	if player
		if col and R_GetColorByName(col)
			local f = io.openlocal(flashfile, "w+")
			f:write(col)
			f:close()
			rawset(_G, "flashcolor", R_GetColorByName(col))
			CONS_Printf(player, "Flash Color set to "..R_GetNameByColor(R_GetColorByName(col)))
		else
			CONS_Printf(player, "cms_flashcolor <color> | Sets the color of Cosmetal's flashing.")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end, COM_LOCAL)

if not jetcolor
	local f = io.openlocal(jetfile, "r")
	if f
		rawset(_G, "jetcolor", R_GetColorByName(f:read("*a")))
		f:close()
	else
		rawset(_G, "jetcolor", SKINCOLOR_YELLOW)
	end
end

if not flashcolor
	local f = io.openlocal(flashfile, "r")
	if f
		rawset(_G, "flashcolor", R_GetColorByName(f:read("*a")))
		f:close()
	else
		rawset(_G, "flashcolor", SKINCOLOR_ORANGE)
	end
end

local tunefilename = "client/CosmicMetal/DJTunes.txt"
COM_AddCommand("cms_metaltunes", function(player, name)
	if player
		if name
			local file = io.openlocal(tunefilename, "w+")
			if name == "default"
				rawset(_G, "metaltunes", "vsmetl")
				file:write("vsmetl")
				file:close()
			elseif name == "race"
				rawset(_G, "metaltunes", "bcz1")
				file:write("bcz1")
				file:close()
			elseif name == "oldrace"
				rawset(_G, "metaltunes", "lgrace")
				file:write("lgrace")
				file:close()
			end
			CONS_Printf(player, "Metal DJ Tunes set to "..name.."!")
		else
			CONS_Printf(player, "cms_metaltunes <default/race/oldrace> | Changes Cosmetal's DJ Music.")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end, COM_LOCAL)

if not metaltunes
	local f = io.openlocal(tunefilename, "r")
	if f
		rawset(_G, "metaltunes", f:read("*a"))
		f:close()
	else
		rawset(_G, "metaltunes", "vsmetl")
	end
end

local csfilename = "client/CosmicMetal/ColorScheme.txt"
COM_AddCommand("cms_metalsupercolor", function(player, arg)
	if player
		if arg and (arg == "cobalt" or arg == "crimson" or arg == "green" or arg == "blackhole")
			local f = io.openlocal(csfilename, "w+")
			f:write(arg)
			f:close()
			rawset(_G, "metalsupercolor", arg)
			CONS_Printf(player, "Metal Super Color set to "..arg..".")
		else
			CONS_Printf(player, "Invalid argument! Usage: cms_metalsupercolor <cobalt/crimson/green/blackhole> | Sets the super color of Cosmetal.")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end, COM_LOCAL)

if not metalsupercolor
	local f = io.openlocal(csfilename, "r")
	if f
		rawset(_G, "metalsupercolor", f:read("*a"))
		f:close()
	else
		rawset(_G, "metalsupercolor", "cobalt")
	end
end

local file = "client/CosmicMetal/BarColor.txt"
COM_AddCommand("cms_barcolor", function(player, col)
	if player
		if col and R_GetColorByName(col)
			local f = io.openlocal(file, "w+")
			f:write(col)
			f:close()
			rawset(_G, "barcolor", R_GetColorByName(col))
			CONS_Printf(player, "Bar Color set to "..R_GetNameByColor(R_GetColorByName(col)))
		else
			CONS_Printf(player, "cms_barcolor <color> | Sets the color of Cosmetal's cooldown bars.")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end, COM_LOCAL)

if not barcolor
	local f = io.openlocal(file, "r")
	if f
		rawset(_G, "barcolor", R_GetColorByName(f:read("*a")))
		f:close()
	else
		rawset(_G, "barcolor", SKINCOLOR_METALLIX)
	end
end

local function tobool(thing)
	thing = thing:lower()
	if thing == "yes" or thing == "on" or thing == "true"
		return true
	elseif thing == "no" or thing == "off" or thing == "false"
		return false
	end
end
COM_AddCommand("cms_chargeabilityswitch", function(player, arg)
	if player
		if arg
			local f = io.openlocal("client/CosmicMetal/AbilSwitch.txt", "w+")
			if tobool(arg) == true
				CONS_Printf(player, "Metal Ability Switch turned on!")
				rawset(_G, "abilswitch", true)
				f:write("true")
				f:close()
			elseif tobool(arg) == false
				CONS_Printf(player, "Metal Ability Switch turned off!")
				rawset(_G, "abilswitch", false)
				f:write("false")
				f:close()
			elseif arg == "help"
				CONS_Printf(player, "Controls wether Cosmetal's charge abilities are switched or not.")
			else
				CONS_Printf(player, "Not an argument! Please use 'on' or 'off'!")
			end
		else
			CONS_Printf(player, "No argument! Please use 'on' or 'off'!")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end, COM_LOCAL)
if not abilswitch
	local f = io.openlocal("client/CosmicMetal/AbilSwitch.txt", "r")
	if f
		rawset(_G, "abilswitch", tobool(f:read("*a")))
	else
		rawset(_G, "abilswitch", false)
	end
end

COM_AddCommand("cms_metalimage_color", function(player, arg)
	if player
		if arg and (arg == "red" or arg == "purple" or arg == "orange" or arg == "blue" or arg == "green" or arg == "skin")
			local f = io.openlocal("client/CosmicMetal/MetalimageColour.txt", "w+")
			f:write(arg)
			f:close()
			rawset(_G, "imagecolor", arg)
			CONS_Printf(player, "Metalimage Color set to "..arg..".")
		else
			CONS_Printf(player, "Usage: cms_metalimage_color <red/orange/green/blue/purple/skin> | Sets the color of Cosmetal's afterimages.")
		end
		S_StartSound(nil, sfx_addfil, player)
	end
end,COM_LOCAL)

if not imagecolor
	local f = io.openlocal("client/CosmicMetal/MetalimageColour.txt", "r")
	if f
		rawset(_G, "imagecolor", f:read("*a"))
	else
		rawset(_G, "imagecolor", "orange")
	end
end

COM_AddCommand("cms_memes", function(player, arg)
	if player
		if arg
			local f = io.openlocal("client/CosmicMetal/Memes.txt", "w+")
			if tobool(arg) == true
				f:write("true")
				rawset(_G, "memes", true)
				CONS_Printf(player, "Memes turned on!")
			elseif tobool(arg) == false
				f:write("false")
				rawset(_G, "memes", false)
				CONS_Printf(player, "Memes turned off!")
			end
			S_StartSound(nil, sfx_addfil, player)
		else
			CONS_Printf(player, "No argument! Please use 'on' or 'off'!")
		end
	end
end,COM_LOCAL)

if not memes
	local f = io.openlocal("client/CosmicMetal/Memes.txt", "r")
	if f
		rawset(_G, "memes", f:read("*a"))
	else
		rawset(_G, "memes", false)
	end
end

COM_AddCommand("cms_subtitles", function(player, arg)
	if player
		if arg
			local f = io.openlocal("client/CosmicMetal/Subtitles.txt", "w+")
			if tobool(arg) == true
				f:write("true")
				rawset(_G, "subtitles", true)
				CONS_Printf(player, "Subtitles turned on!")
			elseif tobool(arg) == false
				f:write("false")
				rawset(_G, "subtitles", false)
				CONS_Printf(player, "Subtitles turned off!")
			end
			S_StartSound(nil, sfx_addfil, player)
		else
			CONS_Printf(player, "No argument! Please use 'on' or 'off'!")
		end
	end
end,COM_LOCAL)

if not subtitles
	local f = io.openlocal("client/CosmicMetal/Subtitles.txt", "r")
	if f
		rawset(_G, "subtitles", f:read("*a"))
	else
		rawset(_G, "subtitles", false)
	end
end

COM_AddCommand("cms_jetsound", function(player, arg)
	if player
		if arg
			local f = io.openlocal("client/CosmicMetal/JetSound.txt", "w+")
			if tobool(arg) == true
				f:write("true")
				rawset(_G, "jetsound", true)
				CONS_Printf(player, "Jet Sound turned on!")
			elseif tobool(arg) == false
				f:write("false")
				rawset(_G, "jetsound", false)
				CONS_Printf(player, "Jet Sound turned off!")
			end
			S_StartSound(nil, sfx_addfil, player)
		else
			CONS_Printf(player, "No argument! Please use 'on' or 'off'!")
		end
	end
end,COM_LOCAL)

if not jetsound
	local f = io.openlocal("client/CosmicMetal/JetSound.txt", "r")
	if f
		rawset(_G, "jetsound", f:read("*a"))
	else
		rawset(_G, "jetsound", false)
	end
end

COM_AddCommand("cms_emeraldshud", function(player, arg)
	if player
		if arg
			local f = io.openlocal("client/CosmicMetal/EmeraldsHUD.txt", "w+")
			if tobool(arg) == true
				f:write("true")
				rawset(_G, "emeraldsHud", true)
				CONS_Printf(player, "Emeralds HUD turned on!")
			elseif tobool(arg) == false
				f:write("false")
				rawset(_G, "emeraldsHud", false)
				CONS_Printf(player, "Emeralds HUD turned off!")
			end
			S_StartSound(nil, sfx_addfil, player)
		else
			CONS_Printf(player, "No argument! Please use 'on' or 'off'!")
		end
	end
end,COM_LOCAL)

if not emeraldsHud
	local f = io.openlocal("client/CosmicMetal/EmeraldsHUD.txt", "r")
	if f
		rawset(_G, "emeraldsHud", f:read("*a"))
	else
		rawset(_G, "emeraldsHud", false)
	end
end