//The Misc file for things such as interactions, crumbling FOFs, everything that doesn't fit with the main file

//Air Curl
addHook("PlayerThink", function(player)
	if player.mo.skin != "cosmetal" then return end
	
	if not P_IsObjectOnGround(player.mo) and not (player.pflags&PF_JUMPED)
	and not (player.pflags&PF_SPINNING) and not (player.pflags&PF_THOKKED)
	and player.playerstate == PST_LIVE and (player.panim != PA_ABILITY
	and player.panim != PA_ABILITY2) and(player.powers[pw_carry] == CR_NONE)
	and not (player.climbing) and not player.boost_canceled
		if (player.cmd.buttons&BT_JUMP or player.cmd.buttons&BT_SPIN)
		and not player.cantrick
		and not(player.pflags&PF_THOKKED) and not(player.pflags&PF_JUMPED)
		and not(player.pflags&PF_SPINNING)
			local afterimage = P_SpawnGhostMobj(player.mo)
			afterimage.fuse = TICRATE/4
			player.mo.state = S_PLAY_JUMP
			player.pflags = $|PF_JUMPED
		end
	end
end)

//Spin Steer by FFoxD
addHook("PlayerThink", function(p)
	if p.mo.skin == "cosmetal"
		if p.pflags & PF_SPINNING and not (p.pflags & PF_STARTDASH)
		and P_IsObjectOnGround(p.mo) then
			p.thrustfactor = (skins[p.mo.skin].thrustfactor)*7
		else
			p.thrustfactor = skins[p.mo.skin].thrustfactor
		end
	end
end)

//Crumble FOF by Frostii
local function CheckAndCrumble2(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.momz + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z + mo.momz > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end

addHook("PlayerThink", function(p)
  if not p.mo return end
  if p.mo.skin != "cosmetal" return end
  if not p.rboosting then return end
	CheckAndCrumble2(p.mo, p.mo.subsector.sector)
end)

addHook("MobjLineCollide", function(mo, line)
  if not mo.player return end
  if mo.skin != "cosmetal" return end
  if not mo.player.rboosting then return end
  for _, sec in ipairs({line.frontsector, line.backsector})
    CheckAndCrumble2(mo, sec)
  end
end, MT_PLAYER)

//Custom Death Anims
local function FireOrZapDie(mo, dmgtype)
	mo.color = SKINCOLOR_GREY
	mo.colorized = true
	if (dmgtype == DMG_FIRE)
		mo.firedie = true
	elseif (dmgtype == DMG_ELECTRIC)
		mo.zapdie = true
	end
end

addHook("MobjDamage", function(mo, i, s, dmgtype)
	if mo.skin != "cosmetal" or mo.player.speeddash then return end
	
	S_StartSound(mo, CMS.HurtSound())
end,MT_PLAYER)

addHook("MobjDeath", function(mo, i, s, dmgtype)
	if mo.skin != "cosmetal" then return end
	
	S_StartSound(mo, sfx_mdie)
	if (dmgtype == DMG_FIRE or dmgtype == DMG_ELECTRIC)
		FireOrZapDie(mo, dmgtype)
	end
end,MT_PLAYER)

addHook("MobjThinker", function(mo)
	if mo.skin != "cosmetal" then return end
	
	if not(mo.health)
		if mo.firedie
			if leveltime%TICRATE/2 == 0
				A_BossScream(mo, 0, MT_PYREFLY_FIRE)
			end
			mo.color = SKINCOLOR_GREY
			mo.colorized = true
		end
		if mo.zapdie
			if leveltime%4 == 0
				mo.color = SKINCOLOR_YELLOW
			else
				mo.color = SKINCOLOR_GREY
			end
			if leveltime%TICRATE/2 == 0
				A_BossScream(mo, 0, MT_WATERZAP)
			end
			mo.colorized = true
		end
	else
		mo.zapdie = false
		mo.firedie = false
	end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(h, v)
	if not (h or h.player)
	return end
	if not (v and v.valid)
	return end
	local p = h.player
	if h.skin == "cosmetal"
	and not (h.z > v.z+v.height)
	and not (v.z > h.z+h.height)
		if ((v.type == MT_SALOONDOOR) or (v.type == MT_SALOONDOORCENTER))
			if h.player and (h.player.speeddash == true)
			and not (v.flags & MF_NOCLIP) and (v and v.valid)
				v.hh = P_SpawnMobj(v.x, v.y, v.z, MT_BOSSEXPLODE)
				v.hh.scale = $*2
				if (v.type == MT_SALOONDOOR)
				v.flags = $|MF_NOCLIP
				P_KillMobj(v, h, h)
				elseif (v.type == MT_SALOONDOORCENTER)
				v.flags = $|MF_NOCLIP
				end
				S_StartSound(h, sfx_bowl)
				return false
			end
		end
	end
end, MT_PLAYER)

//Music Stuff
addHook("MusicChange", function(oldname, newname)
	if consoleplayer
		local character = skins[consoleplayer.skin].name
		if character == "cosmetal"
			if newname == "_super"
				if consoleplayer.hyper and consoleplayer.hyper.capable
					return "SSZB"
				else
					return "VSMETL"
				end
			elseif memes == true and newname == "_drown"
				return "TDROWN"
			elseif newname == "_clear"
				return "MCLEAR"
			end
		end
	end
end)

//XMomentum Trick Boost Sound
addHook("PlayerThink", function(p)
	if not p.isxmomentum or not(p.mo and p.mo.valid) then return end
	if P_IsObjectOnGround(p.mo) and p.trickboostcount > 0 and p.mo.health
		--print("test")
		if p.mo.skin == "cosmetal"
			if p.mo.rollangle <= ANG60 and p.mo.rollangle >= ANG350 - ANG30 - ANG20
				if p.trickboostcount == 10 
					S_StartSound(p.mo, CMS.BoostSound())
				end
			else
				S_StartSound(p.mo, sfx_mdie)
			end
		end
	end
end)

//End Level Win Sound
addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) or p.mo.skin != "cosmetal" then return end
	
	if (p.exiting or p.pflags&PF_FINISHED) and not p.winsound
		S_StartSound(p.mo, sfx_mwin)
		p.winsound = true
	end
end)

//NetVars because it's important for some reason idk
addHook("NetVars", function(net)
	jetcolor = net(jetcolor)
	flashcolor = net(flashcolor)
	metaltunes = net(metaltunes)
	metalsupercolor = net(metalsupercolor)
	abilswitch = net(abilswitch)
	imagecolor = net(imagecolor)
	memes = net(memes)
	subtitles = net(subtitles)
	jetsound = net(jetsound)
	emeraldsHud = net(emeraldsHud)
end)